-- name: [CS] MIPS
-- description: MIPS with custom sounds!

local E_MODEL_MIPSP = smlua_model_util_get_id("mipsp_geo")
local E_MODEL_MIPSC = smlua_model_util_get_id("mipsc_geo")

local TEXT_MOD_NAME = "MIPS"

local VOICETABLE_MIPS = {
    [CHAR_SOUND_ATTACKED] = 'M_hurt.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'M_nya.ogg',
    [CHAR_SOUND_HAHA] = 'M_haahaa.ogg',
    [CHAR_SOUND_HAHA_2] = 'M_haahaa.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'M_yaha2.ogg',
    [CHAR_SOUND_HOOHOO] = 'M_jump2.ogg',
    [CHAR_SOUND_ON_FIRE] = {'M_burning1.ogg', 'M_burning2.ogg'},
    [CHAR_SOUND_OOOF] = 'M_oof.ogg',
    [CHAR_SOUND_OOOF2] = 'M_oof2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'M_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'M_wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'M_yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'M_bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'M_boing.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'M_oooh.ogg',
    [CHAR_SOUND_WAH2] = 'M_jump2.ogg',
    [CHAR_SOUND_WHOA] = 'M_woah.ogg',
    [CHAR_SOUND_YAHOO] = 'M_byahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'M_byahoo.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = {'M_jump1.ogg', 'M_jump2.ogg', 'M_jump3.ogg'},
    [CHAR_SOUND_OKEY_DOKEY] = 'M_yaha.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'M_yaha.ogg',
    [CHAR_SOUND_DYING] = 'M_dead.ogg',
    [CHAR_SOUND_DROWNING] = 'M_drown.ogg',
    [CHAR_SOUND_EEUH] = 'M_unh.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'M_whine.ogg',
    [CHAR_SOUND_DOH] = 'M_oof.ogg',
    [CHAR_SOUND_HRMM] = 'M_chomp.ogg',
    [CHAR_SOUND_PANTING] = 'M_pant.ogg',
    [CHAR_SOUND_UH] = 'M_oof.ogg',
    [CHAR_SOUND_SNORING1] = {'M_snoring1.ogg', 'M_snoring3.ogg'},
    [CHAR_SOUND_SNORING2] = {'M_snoring2.ogg', 'M_snoring4.ogg'},
    [CHAR_SOUND_YAWNING] = 'M_yawn.ogg',
}

local TEX_MIPSP = get_texture_info("mipsp-icon")

if _G.charSelectExists then
    _G.charSelect.character_add("Mips", {"Mips the rabbit", "Cute!!"}, "Rabblet", {r = 245, g = 196, b = 64}, E_MODEL_MIPSP, CT_MARIO, TEX_MIPSP)
    _G.charSelect.character_add("Mips Colors", {"Mips the rabbit", "But colorable!"}, "Rabblet", {r = 234, g = 0, b = 255}, E_MODEL_MIPSC, CT_MARIO, TEX_MIPSP)

    _G.charSelect.character_add_voice(E_MODEL_MIPSP, VOICETABLE_MIPS)
    _G.charSelect.character_add_voice(E_MODEL_MIPSC, VOICETABLE_MIPS)

    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIPS then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MIPS then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
